/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"fmt"
)

// MessageItemType the model 'MessageItemType'
type MessageItemType string

// List of MessageItemType
const (
	ITEM MessageItemType = "item"
	SECTION MessageItemType = "section"
)

// All allowed values of MessageItemType enum
var AllowedMessageItemTypeEnumValues = []MessageItemType{
	"item",
	"section",
}

func (v *MessageItemType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := MessageItemType(value)
	for _, existing := range AllowedMessageItemTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid MessageItemType", value)
}

// NewMessageItemTypeFromValue returns a pointer to a valid MessageItemType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewMessageItemTypeFromValue(v string) (*MessageItemType, error) {
	ev := MessageItemType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for MessageItemType: valid values are %v", v, AllowedMessageItemTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v MessageItemType) IsValid() bool {
	for _, existing := range AllowedMessageItemTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to MessageItemType value
func (v MessageItemType) Ptr() *MessageItemType {
	return &v
}

type NullableMessageItemType struct {
	value *MessageItemType
	isSet bool
}

func (v NullableMessageItemType) Get() *MessageItemType {
	return v.value
}

func (v *NullableMessageItemType) Set(val *MessageItemType) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageItemType) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageItemType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageItemType(val *MessageItemType) *NullableMessageItemType {
	return &NullableMessageItemType{value: val, isSet: true}
}

func (v NullableMessageItemType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageItemType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

